DROP
MATERIALIZED VIEW MV_HEIDLER PRESERVE TABLE;

CREATE MATERIALIZED VIEW "AWIS"."MV_HEIDLER" ("SATZKENNUNG", "KNDNR", "EMPF_NAME1", "EMPF_NAME2", "EMPF_NAME3", "EMPF_STRASSE", "EMPF_LKZ", "EMPF_PLZ",
    "EMPF_ORT", "TRACKING_NR", "ATU_NR", "REFERENZNR", "KENN1", "LAGERKZ", "DATUM_KOMMISSIONIERUNG", "MENGE", "VERBUCHTE_MENGE", "AUFTRAG_ID", "LABEL_GENDATE",
    "VERSANDART", "GEWICHT_NETTO", "PACKSTKNR", "MANDANT") ORGANIZATION HEAP PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING STORAGE(INITIAL
  65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645 PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE
DEFAULT) TABLESPACE "USERS" BUILD IMMEDIATE USING INDEX REFRESH COMPLETE ON DEMAND USING DEFAULT LOCAL ROLLBACK SEGMENT USING ENFORCED CONSTRAINTS DISABLE
QUERY REWRITE
AS
  SELECT
    *
  FROM
    (
      SELECT
        NVS.SATZKENNUNG ,
        NVS.KNDNR ,
        NVS.EMPF_NAME1 ,
        NVS.EMPF_NAME2 ,
        NVS.EMPF_NAME3 ,
        NVS.EMPF_STRASSE ,
        NVS.EMPF_LKZ ,
        NVS.EMPF_PLZ ,
        NVS.EMPF_ORT ,
        NVS.TRACKING_NR ,
        NVS.ATU_NR ,
        NVS.REFERENZNR ,
        NVS.KENN1 ,
        NVS.LAGERKZ ,
        TO_DATE(NVS.DATUM_KOMMISSIONIERUNG || ' ' || NVS.ZEIT_KOMMISSIONIERUNG) AS DATUM_KOMMISSIONIERUNG ,
        NVS.MENGE ,
        NVS.VERBUCHTE_MENGE ,
        TO_CHAR(NVS.AUFTRAG_ID) AS AUFTRAG_ID ,
        NVS.LABEL_GENDATE ,
        NVS.VERSANDART ,
        NVS.GEWICHT_NETTO ,
        ''           AS PACKSTKNR ,
        MAN.KUNDENNR AS MANDANT
      FROM
        NVS_HEIDLER_ARCHIV@NVS NVS
        LEFT JOIN MANDANT@NVSWEN MAN
          ON
            NVS.MANDANT = MAN.AUFTRAGGEBERID
            AND MAN.LAGER = 'L'
      UNION ALL
      SELECT
        NVSWEN.SATZKENNUNG ,
        NVSWEN.KNDNR ,
        NVSWEN.EMPF_NAME1 ,
        NVSWEN.EMPF_NAME2 ,
        NVSWEN.EMPF_NAME3 ,
        NVSWEN.EMPF_STRASSE ,
        NVSWEN.EMPF_LKZ ,
        NVSWEN.EMPF_PLZ ,
        NVSWEN.EMPF_ORT ,
        NVSWEN.TRACKING_NR ,
        NVSWEN.ATU_NR ,
        NVSWEN.REFERENZNR ,
        NVSWEN.KENN1 ,
        NVSWEN.LAGERKZ ,
        TO_DATE(NVSWEN.DATUM_KOMMISSIONIERUNG || ' ' || NVSWEN.ZEIT_KOMMISSIONIERUNG) AS DATUM_KOMMISSIONIERUNG ,
        NVSWEN.MENGE ,
        NVSWEN.VERBUCHTE_MENGE ,
        TO_CHAR(NVSWEN.AUFTRAG_ID) AS AUFTRAG_ID ,
        NULL                       AS LABEL_GENDATE ,
        '1'                        AS VERSANDART ,
        NVSWEN.GEWICHT_NETTO ,
        ''           AS PACKSTKNR ,
        MAN.KUNDENNR AS MANDANT
      FROM
        NVS_HEIDLER_ARCHIV@NVSWEN NVSWEN
        LEFT JOIN MANDANT@NVSWEN MAN
          ON
            NVSWEN.MANDANT = MAN.AUFTRAGGEBERID
            AND MAN.LAGER    = 'N'
      UNION ALL
      SELECT
        NVSWEN.SATZKENNUNG ,
        NVSWEN.KNDNR ,
        NVSWEN.EMPF_NAME1 ,
        NVSWEN.EMPF_NAME2 ,
        NVSWEN.EMPF_NAME3 ,
        NVSWEN.EMPF_STRASSE ,
        NVSWEN.EMPF_LKZ ,
        NVSWEN.EMPF_PLZ ,
        NVSWEN.EMPF_ORT ,
        NVSWEN.TRACKING_NR ,
        NVSWEN.ATU_NR ,
        NVSWEN.REFERENZNR ,
        NVSWEN.KENN1 ,
        NVSWEN.LAGERKZ ,
        TO_DATE(NVSWEN.DATUM_KOMMISSIONIERUNG || ' ' || NVSWEN.ZEIT_KOMMISSIONIERUNG) AS DATUM_KOMMISSIONIERUNG ,
        NVSWEN.MENGE ,
        NVSWEN.VERBUCHTE_MENGE ,
        NVSWEN.AUFTRAGSNR AS AUFTRAG_ID ,
        NVSWEN.LABEL_GENDATE ,
        NVSWEN.VERSANDART ,
        NVSWEN.GEWICHT_NETTO ,
        ''           AS PACKSTKNR ,
        MAN.KUNDENNR AS MANDANT
      FROM
        NVS_HEIDLER_ECOMMERCE@NVSWEN NVSWEN
        LEFT JOIN MANDANT@NVSWEN MAN
          ON
            NVSWEN.MANDANT = MAN.AUFTRAGGEBERID
            AND MAN.LAGER    = 'N'
      UNION ALL
      SELECT
        NVSWEN.SATZKENNUNG ,
        NVSWEN.KNDNR ,
        NVSWEN.EMPF_NAME1 ,
        NVSWEN.EMPF_NAME2 ,
        NVSWEN.EMPF_NAME3 ,
        NVSWEN.EMPF_STRASSE ,
        NVSWEN.EMPF_LKZ ,
        NVSWEN.EMPF_PLZ ,
        NVSWEN.EMPF_ORT ,
        NVSWEN.TRACKING_NR ,
        '??????'              AS ATU_NR ,
        NVSWEN.LIEFERSCHEINNR AS REFERENZNR ,
        NULL                  AS KENN1 ,
        'N'                   AS LAGERKZ ,
        NVSWEN.DATUM_KOMMISSIONIERUNG ,
        0   AS MENGE ,
        0   AS VERBUCHTE_MENGE ,
        '0' AS AUFTRAG_ID ,
        NVSWEN.LABEL_GENDATE ,
        NVSWEN.VERSANDART ,
        NVSWEN.GEWICHT_NETTO ,
        NVSWEN.PACKSTUECK_NR || '/' || PACKSTUECK_NR AS PACKSTKNR ,
        MAN.KUNDENNR                                 AS MANDANT
      FROM
        TAGESABSCHLUSS@NVSWEN NVSWEN
        LEFT JOIN MANDANT@NVSWEN MAN
          ON
            NVSWEN.MANDANT = MAN.AUFTRAGGEBERID
            AND MAN.LAGER    = 'N'
      UNION ALL
      SELECT
        '?'                      AS SATZKENNUNG ,
        LPAD(NVSWEN.KNDNR, 4, 0) AS KNDNR ,
        NVSWEN.NAME_1            AS EMPF_NAME1 ,
        NVSWEN.NAME_2            AS EMPF_NAME2 ,
        NVSWEN.NAME_3            AS EMPF_NAME3 ,
        NVSWEN.EMPF_STRASSE      AS EMPF_STRASSE ,
        NVSWEN.EMPF_LKZ          AS EMPF_LKZ ,
        NVSWEN.EMPF_PLZ          AS EMPF_PLZ ,
        NVSWEN.EMPF_ORT          AS EMPF_ORT ,
        NVSWEN.PAKETSCHEINNR     AS TRACKING_NR ,
        NULL                     AS ATU_NR ,
        NULL                     AS REFERENZNR ,
        NULL                     AS KENN1 ,
        'N'                      AS LAGERKZ ,
        NVSWEN.DATUM             AS DATUM_KOMMISSIONIERUNG ,
        0                        AS MENGE ,
        0                        AS VERBUCHTE_MENGE ,
        '0'                      AS AUFTRAG_ID ,
        NULL                     AS LABEL_GENDATE ,
        '2' VERSANDART ,
        NVSWEN.GEWICHT AS GEWICHT_NETTO ,
        NVSWEN.PACKSTKNR ,
        MAN.KUNDENNR AS MANDANT
      FROM
        DPD_EXPORT@NVSWEN NVSWEN
        LEFT JOIN MANDANT@NVSWEN MAN
          ON
            NVSWEN.MANDANT = MAN.AUFTRAGGEBERID
            AND MAN.LAGER    = 'N'
    )
  WHERE
    DATUM_KOMMISSIONIERUNG > ADD_MONTHS( TRUNC(SYSDATE), -18 );

COMMENT ON MATERIALIZED VIEW "AWIS"."MV_HEIDLER"
IS
'snapshot table for snapshot AWIS.MV_HEIDLER';
